//  FFazenda vers. 1.65                     
//  Copyright (c) Unicontrollers, Ltd., 2013--2016.  All rights reserved.
//  Written by Andrey V. Stolyarov.
// 
//  This is free software.  Permission is granted to everyone to use, copy 
//  or modify this software under the terms and conditions of 
//  GNU GENERAL PUBLIC LICENSE, v.3.0
//  as published by Free Software Foundation (see the file gpl-3.0.txt)   
//                                                                         
//  Please visit http://www.unicontrollers/soft/ffazenda to get a fresh copy
//  This code is provided strictly and exclusively on the "AS IS" basis. 
//  THERE IS NO WARRANTY OF ANY KIND, NEITHER EXPRESSED NOR IMPLIED NOR
//  WHATEVER YOU CAN, OR CAN'T, IMAGINE.  IF THIS IS IMPOSSIBLE DUE TO LOCAL
//  LAW REGULATIONS, THEN THE LICENCE IS AUTOMATICALLY REVOKED FOR USERS WHO
//  LIVE IN SUCH LEGAL SYSTEMS.
// 




#ifndef DEVICES_HPP_SENTRY
#define DEVICES_HPP_SENTRY

#include <sue/sue_sel.hpp>
#include <scriptpp/scrvar.hpp>

void devices_init(class SUEEventSelector *selector);

enum output_actions {
    outact_nop = 0,
    outact_on = 1,
    outact_off = 2,
    outact_switch = 3
};

bool devices_output_action(const char *channel_id, output_actions act);

enum dev_line_states {
    linestate_no_line  =-2,
    linestate_dev_lost =-1,
    linestate_off      = 0,
    linestate_on       = 1
};

int devices_line_status(const char *line_id);

class DevicePoller : public SUETimeoutHandler {
    SUEEventSelector *selector;
    int interval, rescan_multiplier, to_rescan;
    int outsync_multiplier, to_outsync;
public:
    DevicePoller(SUEEventSelector *a_sel, int interv_ms,
                 int rescan_mul, int outsync_mul);
    ~DevicePoller();
    virtual void TimeoutHandle();
};

ScriptVariable devices_report();

#endif
