//  FFazenda vers. 1.65                     
//  Copyright (c) Unicontrollers, Ltd., 2013--2016.  All rights reserved.
//  Written by Andrey V. Stolyarov.
// 
//  This is free software.  Permission is granted to everyone to use, copy 
//  or modify this software under the terms and conditions of 
//  GNU GENERAL PUBLIC LICENSE, v.3.0
//  as published by Free Software Foundation (see the file gpl-3.0.txt)   
//                                                                         
//  Please visit http://www.unicontrollers/soft/ffazenda to get a fresh copy
//  This code is provided strictly and exclusively on the "AS IS" basis. 
//  THERE IS NO WARRANTY OF ANY KIND, NEITHER EXPRESSED NOR IMPLIED NOR
//  WHATEVER YOU CAN, OR CAN'T, IMAGINE.  IF THIS IS IMPOSSIBLE DUE TO LOCAL
//  LAW REGULATIONS, THEN THE LICENCE IS AUTOMATICALLY REVOKED FOR USERS WHO
//  LIVE IN SUCH LEGAL SYSTEMS.
// 




#include <stdlib.h>
#include <unistd.h>

#include <scriptpp/scrvar.hpp>
#include <scriptpp/scrvect.hpp>
// #include <sue/sue_sel.hpp>
#include <sue/sue_wait.hpp>

#include "textsubs.hpp"
#include "flog.hpp"

#include "evexec.hpp"


// SUEEventSelector  *the_selector = 0;



extern SUEChildWaitAgent *the_child_agent;  // from the main.cpp file

void process_event_exec(const char *cmd, const ScriptVector &evt_argv)
{
    ScriptVariable command = FFSubstitution(cmd, evt_argv);
    log_message("Executing event-associated command: [%s]",
                command.c_str());
    int pid = fork();
    if(pid == 0) { /* we're in the child! */
        for(int d = 3; d < 32; d++)  // yes, this is a very bad hack!
            if(d != log_fileno())
                close(d);
        int res = system(command.c_str());
        if(res == -1) {
            log_message("Command execution failed (system returned -1)");
        } else {
            log_message("Command completed, code == %d", res);
        }
        exit(0);
    } else
    if(pid == -1) {
        log_message("Fork failed when tried to execute external command");
    } else {
        new SUEChildHandler(pid, the_child_agent); // it'll take care
    }
}

