//  FFazenda vers. 1.65                     
//  Copyright (c) Unicontrollers, Ltd., 2013--2016.  All rights reserved.
//  Written by Andrey V. Stolyarov.
// 
//  This is free software.  Permission is granted to everyone to use, copy 
//  or modify this software under the terms and conditions of 
//  GNU GENERAL PUBLIC LICENSE, v.3.0
//  as published by Free Software Foundation (see the file gpl-3.0.txt)   
//                                                                         
//  Please visit http://www.unicontrollers/soft/ffazenda to get a fresh copy
//  This code is provided strictly and exclusively on the "AS IS" basis. 
//  THERE IS NO WARRANTY OF ANY KIND, NEITHER EXPRESSED NOR IMPLIED NOR
//  WHATEVER YOU CAN, OR CAN'T, IMAGINE.  IF THIS IS IMPOSSIBLE DUE TO LOCAL
//  LAW REGULATIONS, THEN THE LICENCE IS AUTOMATICALLY REVOKED FOR USERS WHO
//  LIVE IN SUCH LEGAL SYSTEMS.
// 




#include <scriptpp/scrvar.hpp>
#include <scriptpp/scrvect.hpp>
#include <scriptpp/scrsubs.hpp>

#include "flog.hpp"
#include "config.hpp"
#include "smscmd.hpp"
#include "textsubs.hpp"
#include "notify.hpp"


void perform_notification(const char *notification)
{
    ScriptVector argv(notification);
    const char *phones = config_get_notification_phones(argv[0].c_str());
    const char *message = config_get_notification_message(argv[0].c_str());
    if(!phones) {
        log_message("Phones not defined for notification ``%s''",
                    argv[0].c_str());
        return;
    }
    if(!message) {
        log_message("No message defined for notification ``%s''",
                    argv[0].c_str());
        return;
    }
    ScriptVector phonesvec(phones);
    if(phonesvec.Length() < 1) {
        log_message("Empty phones list for notification ``%s''",
                    argv[0].c_str());
        return;
    }
    ScriptVariable msg = FFSubstitution(message, argv);
    msg.Trim();
    if(msg.Length() < 1) {
        log_message("Empty message for notification [%s]",
                    notification);
        return;
    }
    for(int i = 0; i < phonesvec.Length(); i++) {
        bool r = send_sms_to(phonesvec[i], msg);
        if(!r) {
            log_message("Warning: failed to send SMS to ``%s''",
                        phonesvec[i].c_str());
        }
    }
}
