//  FFazenda vers. 1.65                     
//  Copyright (c) Unicontrollers, Ltd., 2013--2016.  All rights reserved.
//  Written by Andrey V. Stolyarov.
// 
//  This is free software.  Permission is granted to everyone to use, copy 
//  or modify this software under the terms and conditions of 
//  GNU GENERAL PUBLIC LICENSE, v.3.0
//  as published by Free Software Foundation (see the file gpl-3.0.txt)   
//                                                                         
//  Please visit http://www.unicontrollers/soft/ffazenda to get a fresh copy
//  This code is provided strictly and exclusively on the "AS IS" basis. 
//  THERE IS NO WARRANTY OF ANY KIND, NEITHER EXPRESSED NOR IMPLIED NOR
//  WHATEVER YOU CAN, OR CAN'T, IMAGINE.  IF THIS IS IMPOSSIBLE DUE TO LOCAL
//  LAW REGULATIONS, THEN THE LICENCE IS AUTOMATICALLY REVOKED FOR USERS WHO
//  LIVE IN SUCH LEGAL SYSTEMS.
// 




#ifndef SMSG_HPP_SENTRY
#define SMSG_HPP_SENTRY

#include <stdio.h>  // for FILE*
#include <scriptpp/scrvect.hpp>

class CommonMessage {
    ScriptVector headers;
    ScriptVector values;
    unsigned char *buf;
    int buf_len, buf_used;

    enum states { Name, Colon, Value, Eol, Body } state;
public:
    CommonMessage(); 
    ~CommonMessage();

    void Clear();
    void FeedByte(unsigned char b);
    void AddHeader(const ScriptVariable &head, const ScriptVariable &val);
    void ClearHeaders();
    void ClearBody();
    void AddByteToBody(unsigned char b);
    void AddStringToBody(const char *str);

    int GetHeadersCount() const;
    bool GetHeader(int idx, ScriptVariable &name, ScriptVariable &val) const;
    ScriptVariable FindHeader(const ScriptVariable& name) const;
    void SetHeader(const ScriptVariable &name, const ScriptVariable &val);

    int GetBodyLength() const { return buf_used; }
    const unsigned char *GetBody() const { return buf; }
    ScriptVariable GetBodyStr() const;

    void OutputMessage(FILE *stream) const;
private:
    void ResizeBody(int atleast);
};



#endif
