//  FFazenda vers. 1.65                     
//  Copyright (c) Unicontrollers, Ltd., 2013--2016.  All rights reserved.
//  Written by Andrey V. Stolyarov.
// 
//  This is free software.  Permission is granted to everyone to use, copy 
//  or modify this software under the terms and conditions of 
//  GNU GENERAL PUBLIC LICENSE, v.3.0
//  as published by Free Software Foundation (see the file gpl-3.0.txt)   
//                                                                         
//  Please visit http://www.unicontrollers/soft/ffazenda to get a fresh copy
//  This code is provided strictly and exclusively on the "AS IS" basis. 
//  THERE IS NO WARRANTY OF ANY KIND, NEITHER EXPRESSED NOR IMPLIED NOR
//  WHATEVER YOU CAN, OR CAN'T, IMAGINE.  IF THIS IS IMPOSSIBLE DUE TO LOCAL
//  LAW REGULATIONS, THEN THE LICENCE IS AUTOMATICALLY REVOKED FOR USERS WHO
//  LIVE IN SUCH LEGAL SYSTEMS.
// 




#include <unistd.h>
#include <sue/sue_sel.hpp>

#include "flog.hpp"
#include "watchdog.hpp"


Watchdog::Watchdog(SUEEventSelector *a_sel, int interv_ms)
    : selector(a_sel), interval(interv_ms)
{
    selector = a_sel;
//    SetFromNow(0);
    log_message("Watchdog interval is %d milliseconds", interval);
    SetFromNow(interval / 1000, (interval % 1000) * 1000);
    selector->RegisterTimeoutHandler(this);
}

Watchdog::~Watchdog()
{
    selector->RemoveTimeoutHandler(this);
}

void Watchdog::TimeoutHandle()
{
    log_message("Watchdog: I'm still alive");
    alarm(interval / 1000 * 2);  // simply die if the main loop hangs
    log_watchdog_reset();
    SetFromNow(interval / 1000, (interval % 1000) * 1000);
    selector->RegisterTimeoutHandler(this);
}

